<?php
if(!isset($config))
	die();

// stripped down version of ezsql/wpdb class - grab it from ezdb.org

define('OBJECT','OBJECT',true);
define('OBJECT_K','OBJECT_K',false);
define('ARRAY_A','ARRAY_A',false);
define('ARRAY_N','ARRAY_N',false);

class db{
	var $ready=false;

	// connects to the database server and selects our database
	function __construct($dbuser,$dbpassword,$dbname,$dbhost){
		register_shutdown_function(array(&$this,"__destruct"));
		$this->dbh=@mysql_connect($dbhost,$dbuser,$dbpassword,true);
		if(!$this->dbh){
			die("Error establishing a database connection");
		}
		$this->ready=true;
		$this->select($dbname);
	}

	// runs when database object is destroyed
	function __destruct(){
		return true;
	}

	// selects a database using the active connection
	function select($db){
		if(!@mysql_select_db($db,$this->dbh)){
			$this->ready=false;
			die("Unable to select database");
		}
	}

	// sanitizes input for writing to database
	function escape($s){
		return mysql_real_escape_string($s);
	}

	// passes sanitized string by reference
	function escape_by_ref(&$s){
		$s=$this->escape($s);
	}

	// prepares a sanitized SQL query
	function prepare($args=null){
		if(is_null($args))
			return;
		$args=func_get_args();
		$query=array_shift($args);
		$query=str_replace("'%s'",'%s',$query);
		$query=str_replace('"%s"','%s',$query);
		$query=str_replace('%s',"'%s'",$query);
		array_walk($args,array(&$this,'escape_by_ref'));
		return @vsprintf($query,$args);
	}

	// flushes cached results
	function flush(){
		$this->last_result=array();
		$this->col_info=null;
	}

	// performs database query using current connection 
	function query($query){
		if(!$this->ready)
			return false;
		$return_val=0;
		$this->flush();
		$this->result=@mysql_query($query,$this->dbh);
		if(mysql_error($this->dbh)){
			return false;
		}
		if(preg_match("/^\\s*(insert|delete|update|replace|alter) /i",$query)){
			$this->rows_affected=mysql_affected_rows($this->dbh);
			if(preg_match("/^\\s*(insert|replace) /i",$query)){
				$this->insert_id=mysql_insert_id($this->dbh);
			}
			$return_val=$this->rows_affected;
		}else{
			$i=0;
			while($i<@mysql_num_fields($this->result)){
				$this->col_info[$i]=@mysql_fetch_field($this->result);
				$i++;
			}
			$num_rows=0;
			while($row=@mysql_fetch_object($this->result)){
				$this->last_result[$num_rows]=$row;
				$num_rows++;
			}
			@mysql_free_result($this->result);
			$this->num_rows=$num_rows;
			$return_val=$this->num_rows;
		}
		return $return_val;
	}

	// returns an array of data into a table
	function insert($table,$data){
		$data=$this->add_magic_quotes($data);
		$fields=array_keys($data);
		return $this->query("INSERT INTO $table (`".implode('`,`',$fields)."`) VALUES ('".implode("','",$data)."')");
	}

	// updates a table using arrays to pass the data and location
	function update($table,$data,$where){
		$data=$this->add_magic_quotes($data);
		$bits=$wheres=array();
		foreach((array)array_keys($data) as $k)
			$bits[]="`$k`='$data[$k]'";
		if(is_array($where))
			foreach($where as $c=>$v)
				$wheres[]="`$c`='".$this->escape($v)."'";
		else
			return false;
		return $this->query("UPDATE $table SET ".implode(', ',$bits).' WHERE '.implode(' AND ',$wheres));
	}

	// returns a single variable from a query
	function get_var($query=null,$x=0,$y=0){
		if($query)
			$this->query($query);
		if(!empty($this->last_result[$y])){
			$values=array_values(get_object_vars($this->last_result[$y]));
		}
		return(isset($values[$x])&&$values[$x]!=='')?$values[$x]:null;
	}

	// returns a single column of a query
	function get_col($query=null,$x=0){
		if($query)
			$this->query($query);
		for($i=0;$i<count($this->last_result);$i++)
			$new_array[$i]=$this->get_var(null,$x,$i);
		return $new_array;
	}

	// returns a row from a query
	function get_row($query=null,$output=OBJECT,$y=0){
		if($query)
			$this->query($query);
		else
			return null;
		if(!isset($this->last_result[$y]))
			return null;
		if($output==OBJECT){
			return $this->last_result[$y]?$this->last_result[$y]:null;
		}elseif($output==ARRAY_A){
			return $this->last_result[$y]?get_object_vars($this->last_result[$y]):null;
		}elseif($output==ARRAY_N){
			return $this->last_result[$y]?array_values(get_object_vars($this->last_result[$y])):null;
		}else{
			die("Output type must be one of: OBJECT, ARRAY_A, ARRAY_N");
		}
	}

	// returns all rows from a query
	function get_results($query=null,$output=OBJECT){
		if($query)
			$this->query($query);
		else
			return null;
		if($output==OBJECT){
			return $this->last_result;
		}elseif($output==OBJECT_K){
			foreach($this->last_result as $row){
				$key=array_shift(get_object_vars($row));
				if(!isset($new_array[$key]))
					$new_array[$key]=$row;
			}
			return $new_array;
		}elseif($output==ARRAY_A||$output==ARRAY_N){
			if($this->last_result){
				$i=0;
				foreach((array)$this->last_result as $row){
					if($output==ARRAY_N){
						$new_array[$i]=array_values(get_object_vars($row));
					}else{
						$new_array[$i]=get_object_vars($row);
					}
					++$i;
				}
				return $new_array;
			}
		}
	}

	// sanitizes an array for writing to the database
	function add_magic_quotes($array){
		foreach((array)$array as $k=>$v){
			if(is_array($v)){
				$array[$k]=$this->add_magic_quotes($v);
			}else{
				$array[$k]=$this->escape($v);
			}
		}
		return $array;
	}
}

function strip($s){
	if(get_magic_quotes_gpc())
		return stripslashes($s);
	else
		return $s;
}

if(!isset($db)) // creates db instance
	$db=new db(DB_USER,DB_PASSWORD,DB_NAME,DB_HOST);
?>